const {csv,select,scaleLinear,extent,axisLeft,axisBottom} = d3;
const csvUrl =
  'https://gist.githubusercontent.com/Ramch16/4209f822c95ec6110d61fd914d78d921/raw/f7c86880574423a30442abb4f9b51fd60d68db91/Test_ICE6_1_RAM.csv'
const parseRow = (d) =>{
  d.bill_length_mm = +d.bill_length_mm;
  d.bill_depth_mm = +d.bill_depth_mm;
  d.flipper_length_mm = +d.flipper_length_mm;
  d.body_mass_g = +d.body_mass_g;
  return d;
};
 const xValue = (d) => d.flipper_length_mm;
    const yValue = (d) => d.body_mass_g;
    const rxValue = (d) => d.bill_length_mm;
    const ryValue = (d) => d.bill_depth_mm;
    const speciesValue = (d) => d.species;
    const margin = {
      top :90,
      right : 30,
      bottom: 100,
      left:120,
    };
  
    const radius = 5;
    const width  = window.innerWidth;
    const height = window.innerHeight;
    const svg = select('body')
                    .append('svg')
            .attr('width',width)
            .attr('height',height);
          const main = async() =>{
    const data = await csv(csvUrl,parseRow);
    const x = scaleLinear()
            .domain(extent(data,xValue))
              .range([margin.left,width-margin.right]);
      const y = scaleLinear()
            .domain(extent(data,yValue))
          .range([height-margin.bottom,margin.top]);
                    
    const marker = (d) =>{
      switch(d){
        case 'Chinstrap' : return 'orange';
        case 'Gentoo' : return 'yellow';
        case 'Adelie' : return 'brown';
      }
    }
  const marks = data.map((d) =>({
    x : x(xValue(d)),
    y : y(yValue(d)),
    species : speciesValue(d),
    color : marker(speciesValue(d)),
    rx : rxValue(d),
    ry : ryValue(d),
  }));
  svg.selectAll('circle')
      .data(marks)
      .join('circle')
      .attr('cx',(d) =>d.x)
      .attr('cy',(d) =>d.y)
      .attr('fill',(d) =>d.color)
      .attr('rx',(d) =>(d.rx))
      .attr('ry',(d) =>(d.ry))
      .attr('r',radius);   
  svg.append('g')
          .attr('transform',
    `translate(${margin.left},0)`)
          .call(axisLeft(y));
    
    svg.append('g')
          .attr('transform',
    `translate(0,
    ${height-margin.bottom})`)
          .call(axisBottom(x));
              
  svg.append('text')
      .attr('class','axis-label')
      .attr('x',innerWidth/2.0)
      .attr('y',50)
      .style('font-size', '30px')
      .text("Scatter Plot")

      svg.append('text')
      .attr('class', 'axis-label')
      .attr('x', width / 2)
      .attr('y', height - 10)
      .style('font-size', '20px')
      .style('text-anchor', 'middle')
      .text('Flipper Length in mm ');

  svg.append('text')
      .attr('x', height - 750)
      .attr('class', 'axis-label')
      .style('font-size', '20px')
      .style('text-anchor', 'middle')
      .attr('y', margin.left/3)
      .text('Bill Length in mm')
      .attr("transform", "rotate(-90)");

};
main();
